<?php
/**
 * InlineObject
 *
 * PHP version 7.3
 *
 * @category Class
 * @package  SLIS\Adapter\Tanss
 * @author   OpenAPI Generator team
 * @link     https://openapi-generator.tech
 */

/**
 * TANSS API
 *
 * ## Documentation of the TANSS API. Version: 5.8.22.1  ### older versions Older versions of the API documentation can be found here: * [Docs for 5.8.21.6](https://api-doc.tanss.de/5.8.21.6/) * [Docs for 5.8.21.3](https://api-doc.tanss.de/5.8.21.3/) * [Docs for 5.8.21.1](https://api-doc.tanss.de/5.8.21.1/) * [Docs for 5.8.20.5](https://api-doc.tanss.de/5.8.20.5/) * [Docs for 5.8.20.4](https://api-doc.tanss.de/5.8.20.4/) * [Docs for 5.8.20.2](https://api-doc.tanss.de/5.8.20.2/) * [Docs for 5.8.19.3](https://api-doc.tanss.de/5.8.19.3/)
 *
 * The version of the OpenAPI document: 5.8.22.1
 * Contact: support@tanss.de
 * Generated by: https://openapi-generator.tech
 * OpenAPI Generator version: 6.0.0-SNAPSHOT
 */

/**
 * NOTE: This class is auto generated by OpenAPI Generator (https://openapi-generator.tech).
 * https://openapi-generator.tech
 * Do not edit the class manually.
 */

namespace SLIS\Adapter\Tanss\Model;

use \ArrayAccess;
use \SLIS\Adapter\Tanss\ObjectSerializer;

/**
 * InlineObject Class Doc Comment
 *
 * @category Class
 * @description query paremeters for fetching a custom ticket list
 * @package  SLIS\Adapter\Tanss
 * @author   OpenAPI Generator team
 * @link     https://openapi-generator.tech
 * @implements \ArrayAccess<TKey, TValue>
 * @template TKey int|null
 * @template TValue mixed|null
 */
class InlineObject implements ModelInterface, ArrayAccess, \JsonSerializable
{
    public const DISCRIMINATOR = null;

    /**
      * The original name of the model.
      *
      * @var string
      */
    protected static $openAPIModelName = 'inline_object';

    /**
      * Array of property to type mappings. Used for (de)serialization
      *
      * @var string[]
      */
    protected static $openAPITypes = [
        'staff' => 'int[]',
        'notAssignedToEmployees' => 'int[]',
        'companies' => 'int[]',
        'departments' => 'int[]',
        'isRepair' => 'bool',
        'remitterId' => 'int',
        'ids' => 'int[]',
        'projectId' => 'int',
        'phaseId' => 'int',
        'includeDoneTickets' => 'bool',
        'types' => 'int[]',
        'states' => 'int[]'
    ];

    /**
      * Array of property to format mappings. Used for (de)serialization
      *
      * @var string[]
      * @phpstan-var array<string, string|null>
      * @psalm-var array<string, string|null>
      */
    protected static $openAPIFormats = [
        'staff' => null,
        'notAssignedToEmployees' => null,
        'companies' => null,
        'departments' => null,
        'isRepair' => null,
        'remitterId' => null,
        'ids' => null,
        'projectId' => null,
        'phaseId' => null,
        'includeDoneTickets' => null,
        'types' => null,
        'states' => null
    ];

    /**
     * Array of property to type mappings. Used for (de)serialization
     *
     * @return array
     */
    public static function openAPITypes()
    {
        return self::$openAPITypes;
    }

    /**
     * Array of property to format mappings. Used for (de)serialization
     *
     * @return array
     */
    public static function openAPIFormats()
    {
        return self::$openAPIFormats;
    }

    /**
     * Array of attributes where the key is the local name,
     * and the value is the original name
     *
     * @var string[]
     */
    protected static $attributeMap = [
        'staff' => 'staff',
        'notAssignedToEmployees' => 'notAssignedToEmployees',
        'companies' => 'companies',
        'departments' => 'departments',
        'isRepair' => 'isRepair',
        'remitterId' => 'remitterId',
        'ids' => 'ids',
        'projectId' => 'projectId',
        'phaseId' => 'phaseId',
        'includeDoneTickets' => 'includeDoneTickets',
        'types' => 'types',
        'states' => 'states'
    ];

    /**
     * Array of attributes to setter functions (for deserialization of responses)
     *
     * @var string[]
     */
    protected static $setters = [
        'staff' => 'setStaff',
        'notAssignedToEmployees' => 'setNotAssignedToEmployees',
        'companies' => 'setCompanies',
        'departments' => 'setDepartments',
        'isRepair' => 'setIsRepair',
        'remitterId' => 'setRemitterId',
        'ids' => 'setIds',
        'projectId' => 'setProjectId',
        'phaseId' => 'setPhaseId',
        'includeDoneTickets' => 'setIncludeDoneTickets',
        'types' => 'setTypes',
        'states' => 'setStates'
    ];

    /**
     * Array of attributes to getter functions (for serialization of requests)
     *
     * @var string[]
     */
    protected static $getters = [
        'staff' => 'getStaff',
        'notAssignedToEmployees' => 'getNotAssignedToEmployees',
        'companies' => 'getCompanies',
        'departments' => 'getDepartments',
        'isRepair' => 'getIsRepair',
        'remitterId' => 'getRemitterId',
        'ids' => 'getIds',
        'projectId' => 'getProjectId',
        'phaseId' => 'getPhaseId',
        'includeDoneTickets' => 'getIncludeDoneTickets',
        'types' => 'getTypes',
        'states' => 'getStates'
    ];

    /**
     * Array of attributes where the key is the local name,
     * and the value is the original name
     *
     * @return array
     */
    public static function attributeMap()
    {
        return self::$attributeMap;
    }

    /**
     * Array of attributes to setter functions (for deserialization of responses)
     *
     * @return array
     */
    public static function setters()
    {
        return self::$setters;
    }

    /**
     * Array of attributes to getter functions (for serialization of requests)
     *
     * @return array
     */
    public static function getters()
    {
        return self::$getters;
    }

    /**
     * The original name of the model.
     *
     * @return string
     */
    public function getModelName()
    {
        return self::$openAPIModelName;
    }


    /**
     * Associative array for storing property values
     *
     * @var mixed[]
     */
    protected $container = [];

    /**
     * Constructor
     *
     * @param mixed[] $data Associated array of property values
     *                      initializing the model
     */
    public function __construct(array $data = null)
    {
        $this->container['staff'] = $data['staff'] ?? null;
        $this->container['notAssignedToEmployees'] = $data['notAssignedToEmployees'] ?? null;
        $this->container['companies'] = $data['companies'] ?? null;
        $this->container['departments'] = $data['departments'] ?? null;
        $this->container['isRepair'] = $data['isRepair'] ?? null;
        $this->container['remitterId'] = $data['remitterId'] ?? null;
        $this->container['ids'] = $data['ids'] ?? null;
        $this->container['projectId'] = $data['projectId'] ?? null;
        $this->container['phaseId'] = $data['phaseId'] ?? null;
        $this->container['includeDoneTickets'] = $data['includeDoneTickets'] ?? null;
        $this->container['types'] = $data['types'] ?? null;
        $this->container['states'] = $data['states'] ?? null;
    }

    /**
     * Show all the invalid properties with reasons.
     *
     * @return array invalid properties with reasons
     */
    public function listInvalidProperties()
    {
        $invalidProperties = [];

        return $invalidProperties;
    }

    /**
     * Validate all the properties in the model
     * return true if all passed
     *
     * @return bool True if all properties are valid
     */
    public function valid()
    {
        return count($this->listInvalidProperties()) === 0;
    }


    /**
     * Gets staff
     *
     * @return int[]|null
     */
    public function getStaff()
    {
        return $this->container['staff'];
    }

    /**
     * Sets staff
     *
     * @param int[]|null $staff fetch only tickets assigned to these employees
     *
     * @return self
     */
    public function setStaff($staff)
    {
        $this->container['staff'] = $staff;

        return $this;
    }

    /**
     * Gets notAssignedToEmployees
     *
     * @return int[]|null
     */
    public function getNotAssignedToEmployees()
    {
        return $this->container['notAssignedToEmployees'];
    }

    /**
     * Sets notAssignedToEmployees
     *
     * @param int[]|null $notAssignedToEmployees don't fetch tickets assigned to these employees
     *
     * @return self
     */
    public function setNotAssignedToEmployees($notAssignedToEmployees)
    {
        $this->container['notAssignedToEmployees'] = $notAssignedToEmployees;

        return $this;
    }

    /**
     * Gets companies
     *
     * @return int[]|null
     */
    public function getCompanies()
    {
        return $this->container['companies'];
    }

    /**
     * Sets companies
     *
     * @param int[]|null $companies fetch only ticket from these companies
     *
     * @return self
     */
    public function setCompanies($companies)
    {
        $this->container['companies'] = $companies;

        return $this;
    }

    /**
     * Gets departments
     *
     * @return int[]|null
     */
    public function getDepartments()
    {
        return $this->container['departments'];
    }

    /**
     * Sets departments
     *
     * @param int[]|null $departments fetch only ticket assigned to these departments
     *
     * @return self
     */
    public function setDepartments($departments)
    {
        $this->container['departments'] = $departments;

        return $this;
    }

    /**
     * Gets isRepair
     *
     * @return bool|null
     */
    public function getIsRepair()
    {
        return $this->container['isRepair'];
    }

    /**
     * Sets isRepair
     *
     * @param bool|null $isRepair if set, will only fetch repair (or no repair) tickets
     *
     * @return self
     */
    public function setIsRepair($isRepair)
    {
        $this->container['isRepair'] = $isRepair;

        return $this;
    }

    /**
     * Gets remitterId
     *
     * @return int|null
     */
    public function getRemitterId()
    {
        return $this->container['remitterId'];
    }

    /**
     * Sets remitterId
     *
     * @param int|null $remitterId if set, will only fetch tickets of this remitter id
     *
     * @return self
     */
    public function setRemitterId($remitterId)
    {
        $this->container['remitterId'] = $remitterId;

        return $this;
    }

    /**
     * Gets ids
     *
     * @return int[]|null
     */
    public function getIds()
    {
        return $this->container['ids'];
    }

    /**
     * Sets ids
     *
     * @param int[]|null $ids fetch only ticket with these ids
     *
     * @return self
     */
    public function setIds($ids)
    {
        $this->container['ids'] = $ids;

        return $this;
    }

    /**
     * Gets projectId
     *
     * @return int|null
     */
    public function getProjectId()
    {
        return $this->container['projectId'];
    }

    /**
     * Sets projectId
     *
     * @param int|null $projectId fetches only tickets of this project
     *
     * @return self
     */
    public function setProjectId($projectId)
    {
        $this->container['projectId'] = $projectId;

        return $this;
    }

    /**
     * Gets phaseId
     *
     * @return int|null
     */
    public function getPhaseId()
    {
        return $this->container['phaseId'];
    }

    /**
     * Sets phaseId
     *
     * @param int|null $phaseId fetches only tickets of a given phase id
     *
     * @return self
     */
    public function setPhaseId($phaseId)
    {
        $this->container['phaseId'] = $phaseId;

        return $this;
    }

    /**
     * Gets includeDoneTickets
     *
     * @return bool|null
     */
    public function getIncludeDoneTickets()
    {
        return $this->container['includeDoneTickets'];
    }

    /**
     * Sets includeDoneTickets
     *
     * @param bool|null $includeDoneTickets by deafult, only \"open\" tickets will be fetched. if \"done\" tickets shall be fetched as well, this has to be given here
     *
     * @return self
     */
    public function setIncludeDoneTickets($includeDoneTickets)
    {
        $this->container['includeDoneTickets'] = $includeDoneTickets;

        return $this;
    }

    /**
     * Gets types
     *
     * @return int[]|null
     */
    public function getTypes()
    {
        return $this->container['types'];
    }

    /**
     * Sets types
     *
     * @param int[]|null $types fetch only ticket with these type ids
     *
     * @return self
     */
    public function setTypes($types)
    {
        $this->container['types'] = $types;

        return $this;
    }

    /**
     * Gets states
     *
     * @return int[]|null
     */
    public function getStates()
    {
        return $this->container['states'];
    }

    /**
     * Sets states
     *
     * @param int[]|null $states fetch only ticket with these state ids
     *
     * @return self
     */
    public function setStates($states)
    {
        $this->container['states'] = $states;

        return $this;
    }
    /**
     * Returns true if offset exists. False otherwise.
     *
     * @param integer $offset Offset
     *
     * @return boolean
     */
    public function offsetExists($offset): bool
    {
        return isset($this->container[$offset]);
    }

    /**
     * Gets offset.
     *
     * @param integer $offset Offset
     *
     * @return mixed|null
     */
    #[\ReturnTypeWillChange]
    public function offsetGet($offset)
    {
        return $this->container[$offset] ?? null;
    }

    /**
     * Sets value based on offset.
     *
     * @param int|null $offset Offset
     * @param mixed    $value  Value to be set
     *
     * @return void
     */
    public function offsetSet($offset, $value): void
    {
        if (is_null($offset)) {
            $this->container[] = $value;
        } else {
            $this->container[$offset] = $value;
        }
    }

    /**
     * Unsets offset.
     *
     * @param integer $offset Offset
     *
     * @return void
     */
    public function offsetUnset($offset): void
    {
        unset($this->container[$offset]);
    }

    /**
     * Serializes the object to a value that can be serialized natively by json_encode().
     * @link https://www.php.net/manual/en/jsonserializable.jsonserialize.php
     *
     * @return mixed Returns data which can be serialized by json_encode(), which is a value
     * of any type other than a resource.
     */
    #[\ReturnTypeWillChange]
    public function jsonSerialize()
    {
       return ObjectSerializer::sanitizeForSerialization($this);
    }

    /**
     * Gets the string presentation of the object
     *
     * @return string
     */
    public function __toString()
    {
        return json_encode(
            ObjectSerializer::sanitizeForSerialization($this),
            JSON_PRETTY_PRINT
        );
    }

    /**
     * Gets a header-safe presentation of the object
     *
     * @return string
     */
    public function toHeaderValue()
    {
        return json_encode(ObjectSerializer::sanitizeForSerialization($this));
    }
}


